#include "ndewidgetanimationmanager.h"

namespace NdeWidget {

bool circlemanager::registerWidget( QWidget* widget,QtMaterialRippleOverlay* ripplelay)
{
    if( !widget ) return false;
    if (!m_ripplelay.contains(widget)) { m_ripplelay.insert( widget,ripplelay);}
    connect( widget, SIGNAL(destroyed(QObject*)), this, SLOT(unregisterWidget(QObject*)), Qt::UniqueConnection );
    return true;
}

QtMaterialRippleOverlay* circlemanager::findripplelay(QWidget* widget)
{
    if( !widget ) return nullptr;
    if(m_ripplelay.find(widget) == m_ripplelay.constEnd()) {
        return nullptr;
    }
    return m_ripplelay.find(widget).value();
}

bool circlemanager::unregisterWidget( QObject* obj)
{
    QWidget *widget = qobject_cast<QWidget *>(obj);
    if( !widget ) return false;
    if( m_ripplelay.find(widget) != m_ripplelay.constEnd() )
    {
        auto iter = m_ripplelay.find(widget);
        m_ripplelay.erase(iter);
        delete iter.value();
    }
    return true;
}

void animationmanager::initialize()
{
    m_circle = new circlemanager();
}

void animationmanager::finalize()
{
    delete m_circle;
}

}
